<?php
declare(strict_types=1);

namespace Flat101\EnhancedEcommerce\Block\Impressions;

use Flat101\EnhancedEcommerce\Block\AbstractDatalayer;
use Flat101\EnhancedEcommerce\Model\DataLayer\Impressions\CatalogImpressionView;
use Magento\Framework\View\Element\Template;
use Flat101\EnhancedEcommerce\Api\DataLayerListInterface;
use Flat101\EnhancedEcommerce\Factory\DataLayerFactory;
use Flat101\EnhancedEcommerce\Helper\Config;
use Magento\Framework\App\Response\RedirectInterface;
use Magento\Framework\Event\Manager;
use Magento\Framework\Serialize\SerializerInterface;
use Magento\Framework\UrlInterface;

class CatalogImpression extends AbstractDatalayer
{
    /** @var CatalogImpressionView */
    protected $catalogImpressionView;

    public function __construct(
        CatalogImpressionView $catalogImpressionView,
        Template\Context $context,
        DataLayerListInterface $dataLayerList,
        DataLayerFactory $dataLayerFactory,
        SerializerInterface $serializer,
        UrlInterface $url,
        Config $config,
        RedirectInterface $redirect,
        Manager $eventManage,
        array $data = []
    ) {
        parent::__construct($context, $dataLayerList, $dataLayerFactory, $serializer, $url, $config, $redirect, $eventManage, $data);
        $this->catalogImpressionView = $catalogImpressionView;
    }

    public function getJsonDataLayers(): ?string
    {
        return $this->serializer->serialize($this->catalogImpressionView->getLayer());
    }
}
