<?php
declare(strict_types=1);

namespace Flat101\EnhancedEcommerce\Model\Config\Source;

use Magento\Framework\Data\OptionSourceInterface;

class CategoryFormat implements OptionSourceInterface
{
    CONST ONLY_MAIN_FORMAT = 1;
    CONST FULL_PATH_FORMAT = 2;
    CONST DEFAULT_FORMAT = self::FULL_PATH_FORMAT;

    /**
     * Options getter
     *
     * @return array
     */
    public function toOptionArray()
    {
        return [
            ['label' => __('Main category name (only one)'), 'value' => self::ONLY_MAIN_FORMAT],
            ['label' => __('Full path'), 'value' => self::FULL_PATH_FORMAT]
        ];
    }

    /**
     * Get options in "key-value" format
     *
     * @return array
     */
    public function toArray()
    {
        return [
            [self::ONLY_MAIN_FORMAT => __('Main category name (only one)')],
            [self::FULL_PATH_FORMAT => __('Full path')]
        ];
    }
}
