<?php
declare(strict_types=1);

namespace Flat101\EnhancedEcommerce\Model\DataLayer;

use Flat101\EnhancedEcommerce\Api\Data\DataLayerInterface;

class CheckoutView implements DataLayerInterface
{
    public const CODE = 'checkout-view';

    private const STEP = 2;
    private const STEP_LABEL = 'step 2 - entrega';
    private const OPTION = 'onCheckoutPage';

    /**
     * @var Generator\CheckoutStep
     */
    private $checkoutStep;

    public function __construct(Generator\CheckoutStep $checkoutStep)
    {
        $this->checkoutStep = $checkoutStep;
    }

    public function getCode(): string
    {
        return self::CODE;
    }

    public function getLayer(): Dto\Ecommerce
    {
        return $this->checkoutStep->onCheckoutStep(self::STEP, self::OPTION, self::STEP_LABEL);
    }
}
