<?php
declare(strict_types=1);

namespace Flat101\EnhancedEcommerce\Model\Handler\Click;

use Flat101\EnhancedEcommerce\Helper\Config;
use Flat101\EnhancedEcommerce\Model\DataLayer\Generator\ClickImpression;
use Flat101\EnhancedEcommerce\Model\Session;
use Magento\Catalog\Model\Product;

class ClickCatalogImpressionHandler implements ClickImpressionHandlerInterface
{
    private const DEFAULT_LIST = 'Catalog Products';

    /** @var Config */
    private $config;

    /** @var Session */
    private $session;

    /** @var ClickImpression */
    private $clickImpressionGenerator;

    public function __construct(
        Session $session,
        ClickImpression $clickImpressionGenerator,
        Config $config
    ) {
        $this->session = $session;
        $this->clickImpressionGenerator = $clickImpressionGenerator;
        $this->config = $config;
    }

    public function handle(Product $product): void
    {
        $productInfo = $this->session->getProductAdditionalInfo(false);
        if ($productInfo[$product->getId()]) {
            $this->session->setClickImpressionProducts(
                $this->clickImpressionGenerator->generate($product, ($productInfo[$product->getId()]['list']) ?? self::DEFAULT_LIST, $productInfo[$product->getId()])
            );
        }
    }

//    protected function getAdditionalProductInfo($product): array
//    {
//        $response = $this->session->getProductAdditionalInfo(true);
//        $allImpressionProducts = $this->session->getImpressionCatalogProducts(true);
//
//        foreach ($allImpressionProducts as $impressionProduct) {
//            if ($impressionProduct->id == $product->getId()) {
//                $list = explode($this->config->getCategorySeparator(), $impressionProduct->category);
//                $response[$impressionProduct->id] = [
//                    'list'      => trim(end($list)),
//                    'category'  => $impressionProduct->category,
//                    'position'  => $impressionProduct->position
//                ];
//            }
//        }
//
//        $this->session->setProductAdditionalInfo($response);
//        return $response;
//    }
}
